//+------------------------------------------------------------------+
//|                                                Yeti-Hadzhing.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

int StopSignal=15; //  ,    -
int TralSignal=7;
int TrallingStop=5; //  ,    
int OpenSignal=8;
extern double ST_Period         =15;
extern double StopLoss   =0;     // SL   
extern double TakeProfit =30;      //    
extern double Lot       =0.1;     //   . 

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
//---- -  
int Tral(int Tral_Stop, bool BuySignal=false, bool SellSignal=false)
{
   string Symb=Symbol();                        // . 
//--------------------------------------------------------------- 2 --
   for(int i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         int Tip=OrderType();                   //  
         if(OrderSymbol()!=Symb||Tip>1)continue;//   
         double SL=OrderStopLoss();             // SL  .
         //------------------------------------------------------ 3 --
         while(true)                            //  
           {
            double TS=Tral_Stop;                //  
            int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);//. 
            if (TS < Min_Dist)                  //   .
               TS=Min_Dist;                     //   TS
            //--------------------------------------------------- 4 --
            bool Modify=false;                  //    
            switch(Tip)                         //   
              {
               case 0 :                         //  Buy
                  if (NormalizeDouble(SL,Digits)< //   .
                     NormalizeDouble(Bid-TS*Point,Digits))
                    {
                     SL=Bid-TS*Point;           //   
                     string Text="Buy ";        //   Buy 
                     Modify=true;               //   .
                    }
                  break;                        //   switch
               case 1 :                         //  Sell
                  if (NormalizeDouble(SL,Digits)> //   .
                     NormalizeDouble(Ask+TS*Point,Digits)
                     || NormalizeDouble(SL,Digits)==0)//  
                    {
                     SL=Ask+TS*Point;           //   
                     Text="Sell ";              //   Sell 
                     Modify=true;               //   .
                    }
              }                                 //  switch
            if (Modify==false)                  //    
               break;                           //   while
            //--------------------------------------------------- 5 --
            double TP    =OrderTakeProfit();    // TP  .
            double Price =OrderOpenPrice();     //  . .
            int    Ticket=OrderTicket();        //  . .
            if ((BuySignal==true) && (OrderType()==OP_BUY) && ((Bid-OrderOpenPrice())/Point > TrallingStop))
            { 
            Alert (" ",Text,Ticket,".  ..");
            bool Ans=OrderModify(Ticket,Price,SL,TP,0);// !
            break;}
            if ((SellSignal==true) && (OrderType()==OP_SELL) && ((OrderOpenPrice()-Ask)/Point > TrallingStop))
            { 
            Alert (" ",Text,Ticket,".  ..");
            Ans=OrderModify(Ticket,Price,SL,TP,0);// !
            break;}
            //--------------------------------------------------- 6 --
            if (Ans==true)                      //  :)
              {
               Alert (" ",Text,Ticket," :)");
               break;                           //   .
              }
            //--------------------------------------------------- 7 --
            int Error=GetLastError();           //   :(
            switch(Error)                       //  
              {
               case 130:Alert(" .   .");
                  RefreshRates();               //  
                  continue;                     //  . 
               case 136:Alert(" .   ..");
                  while(RefreshRates()==false)  //   
                     Sleep(1);                  //   
                  continue;                     //  . 
               case 146:Alert("  . ");
                  Sleep(500);                   //  
                  RefreshRates();               //  
                  continue;                     //  . 
                  //  
               case 2 : Alert(" .");
                  break;                        //   switch
               case 5 : Alert("   .");
                  break;                        //   switch
               case 64: Alert(" .");
                  break;                        //   switch
               case 133:Alert(" ");
                  break;                        //   switch
               default: Alert("  ",Error);//. 
              }
            break;                              //   .
           }                                    //   .
         //------------------------------------------------------ 8 --
        }                                       //   .
     }                                          //   .
//--------------------------------------------------------------- 9 --
   return;                                      //   start()
}
  
//---- -   
int CloseBy()
{
    for (int i=1; i<=OrdersTotal(); i++)       //   ,..     
       { 
       int Ticket_Buy=0;
       int Ticket_Sell=0;
       double Price_Buy=0;
       double Price_Sell=0;     
                if(OrderSelect(0,SELECT_BY_POS,MODE_TRADES))  
                      {  
                      if(OrderType()==OP_SELL) {
                      Ticket_Sell=OrderTicket();
                      Price_Sell=OrderOpenPrice();}
                      else {Ticket_Buy=OrderTicket();
                      Price_Buy=OrderOpenPrice();}
                      }
                if(OrderSelect(1,SELECT_BY_POS,MODE_TRADES))  
                      {
                      if(OrderType()==OP_BUY) {
                      Ticket_Buy=OrderTicket();
                      Price_Buy=OrderOpenPrice();}
                      else {Ticket_Sell=OrderTicket();
                      Price_Sell=OrderOpenPrice();}
                      }
                bool Ans=OrderCloseBy(Ticket_Buy,Ticket_Sell);
                if (Ans==true)                            //  :)
                Alert ("  ",Ticket_Buy,"  ",Ticket_Sell);
       }
}

//---- -  
int DoubleOrderSend(int BuySellSignal)
{
if (BuySellSignal==0)
   {
   Alert("  Buy-");
   OrderSend(Symbol(),OP_BUY,Lot,Ask,3,0,0);
   OrderSend(Symbol(),OP_BUY,Lot,Ask,3,0,0);
   return;
   }
if (BuySellSignal==1)
   {
   Alert("  Sell-");
   OrderSend(Symbol(),OP_SELL,Lot,Bid,3,0,0);
   OrderSend(Symbol(),OP_SELL,Lot,Bid,3,0,0);
   return;
   }
}

//----
int start()
{
//---- 
int Orders=0, buys=0, sells=0;
int res;
double Blue_0, Blue_1, Red_0, Red_1, CCI_0, CCI_1, CCI_2, BB_UP, BB_LOW, MA12_0, MA12_1;

//---- 
//---- 
for (int i=1; i<=OrdersTotal(); i++)       //   ,..     
       {                               //        
       if(OrderSelect(i-1,SELECT_BY_POS)==true)//          
          { 
          if(OrderType()==OP_BUY)  buys++;
          if(OrderType()==OP_SELL) sells++;                     //    ..         
          Orders++;  
          }     
       }
Comment(" ,  ",Orders," : ",buys,"   ",sells," "); 

//---- 
if (Orders>0) 
{
    for (i=1; i<=OrdersTotal(); i++)       //   ,..     
       { 
       int Profit=0; int ProfitBuy=0; int ProfitSell=0;
       for (i=1; i<=OrdersTotal(); i++)  
          {     //   ,..     
          if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
              { 
              if (OrderType()==OP_BUY)
                    {
                    Profit=Profit+((Bid-OrderOpenPrice())/Point);
                    ProfitBuy=ProfitBuy+((Bid-OrderOpenPrice())/Point);
                    }
              if (OrderType()==OP_SELL)
                    {
                    Profit=Profit+((OrderOpenPrice()-Ask)/Point);
                    ProfitSell=ProfitSell+((OrderOpenPrice()-Ask)/Point);
                    }   
              }
         }
         Alert("     ",Profit-OrdersTotal()*5,";  :",ProfitBuy,",  :",ProfitSell);
      }
}

//---- 


//---- 
Blue_0 = iStochastic(NULL,0,ST_Period,3,3,MODE_SMA,0,MODE_MAIN,  0);// 0 
Blue_1 = iStochastic(NULL,0,ST_Period,3,3,MODE_SMA,0,MODE_MAIN,  1);// 1 
Red_0 = iStochastic(NULL,0,ST_Period,3,3,MODE_SMA,0,MODE_SIGNAL,0);// 0 
Red_1 = iStochastic(NULL,0,ST_Period,3,3,MODE_SMA,0,MODE_SIGNAL,1);// 1 

if (Orders==0)
    {
    Alert(" ");
//---- sell conditions
    if((Red_0-Blue_0)>OpenSignal && Blue_0>10) // 
       {
       res=OrderSend(Symbol(),OP_SELL,Lot,Bid,3,0,0,0);
       return;
       }
//---- buy conditions

    if((Blue_0-Red_0)>OpenSignal && Red_0<90) // 
       {
       res=OrderSend(Symbol(),OP_BUY,Lot,Ask,3,0,0,0);
       return;
       }
    }
    
//---- : 1   1 
if (Orders==1 && buys==1)
   {
   if (Profit>0 && ProfitBuy>TralSignal) Tral(TrallingStop,true,false);
   if (ProfitBuy<-StopSignal) DoubleOrderSend(1);
   }
if (Orders==1 && sells==1)
   {
   if (Profit>0 && ProfitSell>TralSignal) Tral(TrallingStop,false,true);
   if (ProfitSell<-StopSignal) DoubleOrderSend(0);
   }
   
//---- : 1   2 
if (Orders==3 && buys==1 && sells==2) 
   { 
   if (Profit>2*TralSignal) 
      {
      CloseBy();
      Tral(TrallingStop,false,true);
      }
   if (ProfitBuy>TralSignal)
      {
      CloseBy();
      DoubleOrderSend(0);
      }
   }
   
//---- : 2   1 
if (Orders==3 && buys==2 && sells==1)
   {
   if (Profit>2*TralSignal)
      {
      CloseBy();
      Tral(TrallingStop,true,false);
      }
   if (ProfitSell>TralSignal)
      {
      CloseBy();
      DoubleOrderSend(1);
      }
   }

}

